package com.gyee.frame.controller.gen;

import com.github.pagehelper.PageInfo;
import com.gyee.frame.common.conf.UserLoginContext;
import com.gyee.frame.common.domain.AjaxResult;
import com.gyee.frame.model.auto.Gyeeuser;
import com.gyee.frame.model.custom.OnlineVo;
import com.gyee.frame.model.custom.TableSplitResult;
import com.gyee.frame.model.custom.Tablepar;
import com.gyee.frame.model.custom.TitleVo;
import com.gyee.frame.model.enumeration.Messagetype;
import com.gyee.frame.netty.websocket.util.SocketToolController;
import com.gyee.frame.service.GyeeuserService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.*;

import java.util.*;

@Controller
@RequestMapping("GyeeuserController")
@Api(value = "")
public class GyeeuserController extends SocketToolController{
	
	private String prefix = "gen/gyeeuser";
	@Autowired
	private GyeeuserService gyeeuserService;
	
	@GetMapping("view")
	@RequiresPermissions("gen:gyeeuser:view")
    public String view(ModelMap model)
    {	
		String str="";
		setTitle(model, new TitleVo("列表", str+"管理", true,"欢迎进入"+str+"页面", true, false));
        return prefix + "/list";
    }
	
	/**
	 * 
		 *@author:Li Miao
		 *
		 *@description: 登录接口
		 *
		 *@param:username,password
		 *
		 *@return:
		 *
		 *@createTime:2020年4月16日
		 *
	 */
	@GetMapping("/login")
	@ResponseBody
	public AjaxResult login(String username,String password){
		Gyeeuser gyeeuser=new Gyeeuser();
		gyeeuser.setUsername(username);
		gyeeuser.setPassword(password);
		String id=gyeeuserService.queryIdByUserNamePassWord(gyeeuser);
		if(id!=""&&id!=null){




			if(UserLoginContext.userLoginMap.containsKey(id))
			{


				this.pushToWeb("pageNumber_4","functionNumber_5",id,"loginout", Messagetype.MESSAGE);


			}else {
				StringBuilder sb=new StringBuilder();
				UserLoginContext.userLoginMap.put(id,id);
			}

			return AjaxResult.successData(200, id);
			
		}else{			
			return AjaxResult.successData(200, "-1");
		}
	}

	@GetMapping("/selectUserList")
	@ResponseBody
	public List<Gyeeuser> selectUserList() {

		List<Gyeeuser> result=gyeeuserService.findUserlist();
		return  result;
	}
	@PostMapping("/selectUserList")
	@ResponseBody
	public List<Gyeeuser> selectUserList(@RequestBody Map<String,String> map) {

		List<Gyeeuser> result=gyeeuserService.findUserlist();
		if( !result.isEmpty())
		{
			for(Gyeeuser user:result)
			{
				if(null!=map && map.containsKey(user.getId()))
				{
					user.setRemak1("1");
				}else
				{
					user.setRemak1("0");
				}
			}
		}
		this.pushToWeb("pageNumber_4","functionNumber_3","all",result, Messagetype.MESSAGE);

		return  result;
	}

	@PostMapping("/onlineUserMap")
	@ResponseBody
	public Map<String,List<String>> onlineUserMap(@RequestBody Map<String,String> map) {


		Map<String,List<String>> onlinemap=new HashMap<>();

		List<OnlineVo> onlinevolist=new ArrayList<>();

		if(null !=map && !map.isEmpty())
		{
			Set<Map.Entry<String, String>> set = map.entrySet();
			for (Iterator<Map.Entry<String, String>> it = set.iterator(); it.hasNext();) {
				Map.Entry<String, String> entry = (Map.Entry<String, String>) it.next();
				//System.out.println(entry.getKey() + "--->" + entry.getValue());

				String key = entry.getKey().substring(0, entry.getKey().indexOf("->"));

				String end = entry.getKey().substring(entry.getKey().indexOf("->")+2);

				if (onlinemap.containsKey(key)) {
					List<String> ls = onlinemap.get(key);
					ls.add(end);
					onlinemap.put(key, ls);
				} else {
					List<String> ls = new ArrayList<>();
					ls.add(end);
					onlinemap.put(key, ls);
				}
			}

			Set<Map.Entry<String, List<String>>> set2 = onlinemap.entrySet();
			for (Iterator<Map.Entry<String, List<String>>> it2 = set2.iterator(); it2.hasNext();) {
				Map.Entry<String, List<String>> entry2 = (Map.Entry<String, List<String>>) it2.next();
				//System.out.println(entry.getKey() + "--->" + entry.getValue());

				OnlineVo vo=new OnlineVo();
				vo.setId(entry2.getKey());
				vo.setUserlist(entry2.getValue());
				onlinevolist.add(vo);
			}
		}


		this.pushToWeb("pageNumber_4","functionNumber_4","all",onlinevolist, Messagetype.MESSAGE);

		return  onlinemap;
	}
	
	//@Log(title = "集合查询", action = "111")
	@PostMapping("list")
	@RequiresPermissions("gen:gyeeuser:list")
	@ResponseBody
	public Object list(Tablepar tablepar,String searchText){
		PageInfo<Gyeeuser> page=gyeeuserService.list(tablepar,searchText) ; 
		TableSplitResult<Gyeeuser> result=new TableSplitResult<Gyeeuser>(page.getPageNum(), page.getTotal(), page.getList()); 
		return  result;
	}
	
	/**
     * 新增
     */

    @GetMapping("/add")
    public String add(ModelMap modelMap)
    {
        return prefix + "/add";
    }
	
	//@Log(title = "新增", action = "111")
	@PostMapping("add")
	@RequiresPermissions("gen:gyeeuser:add")
	@ResponseBody
	public AjaxResult add(Gyeeuser gyeeuser){
		int b=gyeeuserService.insertSelective(gyeeuser);
		if(b>0){
			return success();
		}else{
			return error();
		}
	}
	
	/**
	 * 删除用户
	 * @param ids
	 * @return
	 */
	//@Log(title = "删除", action = "111")
	@PostMapping("remove")
	@RequiresPermissions("gen:gyeeuser:remove")
	@ResponseBody
	public AjaxResult remove(String ids){
		int b=gyeeuserService.deleteByPrimaryKey(ids);
		if(b>0){
			return success();
		}else{
			return error();
		}
	}
	
	/**
	 * 检查用户
	 * @return
	 */
	@PostMapping("checkNameUnique")
	@ResponseBody
	public int checkNameUnique(Gyeeuser gyeeuser){
		int b=gyeeuserService.checkNameUnique(gyeeuser);
		if(b>0){
			return 1;
		}else{
			return 0;
		}
	}
	
	
	/**
	 * 修改跳转
	 * @param id
	 * @param mmap
	 * @return
	 */
	@GetMapping("/edit/{id}")
    public String edit(@PathVariable("id") String id, ModelMap mmap)
    {
        mmap.put("Gyeeuser", gyeeuserService.selectByPrimaryKey(id));

        return prefix + "/edit";
    }
	
	/**
     * 修改保存
     */
    //@Log(title = "修改", action = "111")
    @RequiresPermissions("gen:gyeeuser:edit")
    @PostMapping("/edit")
    @ResponseBody
    public AjaxResult editSave(Gyeeuser record)
    {
        return toAjax(gyeeuserService.updateByPrimaryKeySelective(record));
    }

    
    /**
   	 * 根据主键查询
   	 * 
   	 * @param id
   	 * @return
   	 */
   	@PostMapping("/get/{id}")
   	@ApiOperation(value = "根据id查询唯一", notes = "根据id查询唯一")
   	public Gyeeuser edit(@PathVariable("id") String id) {
   		return gyeeuserService.selectByPrimaryKey(id);
   	}
    

	
}
